part of fisher;

Math.Random _rand = new Math.Random();

// Settings

String DEFAULT_VECTOR_NAME = "unnamed";
int DIGITS = 3;

// Helpers

_extractNumList(x) => 
  x is num ? [x] :
    x is NumericVector ? x.data :
      x is BooleanVector ? x.data.map((bool a) => a ? 1 : 0).toList() :
        x;

_extractBoolList(x) =>
  x is bool ? [x] :
    x is BooleanVector ? x.data :
      x is NumericVector ? x.data.map((num a) => a != 0).toList() :
        x;

_extractStrList(x) =>
  x is String ? [x] :
    x is CategoricVector ? x.data :
      x is NumericVector ? _extractStrList(x.data) :
        x is BooleanVector ? _extractStrList(x.data) :
          (x is List) && !(x.first is String) ? 
            x.map((a) => a.toString()).toList() :
              x;

_vector(
  ofSameTypeAs, 
  List data, 
  {
    String name, 
    List<String> categories
  }
) => ofSameTypeAs is NumericVector ? 
  new NumericVector(data: data, name: name) :
    ofSameTypeAs is BooleanVector ? 
      new BooleanVector(data: data, name: name) : 
        ofSameTypeAs is CategoricVector ? 
          new CategoricVector(data: data, name: name, categories: categories) :
        null;